#!C:/perl/bin/perl.exe
# creates RoqetPad.XML file
# Last updated: 2010-12-30
#
# script copyright 2010/2011 by roqet
# and can be distributed and modified under the terms of the 
# GNU General Public License, available at: 
# http://www.gnu.org/copyleft/gpl.html
# More scripts and software at: http://www.roqet.org/software.html
#  ~~~
#  'l'
#   -
#

use XML::Simple;

$instance = $ARGV[0];
if ($instance eq '') { die "error: no instance specified: $!\n"; }
$truecrypt_volume = $ARGV[1];
if ($truecrypt_volume eq '') { die "error: no truecrypt volume (put nil if you're not using truecrypt): $!\n"; }
$truecrypt_mount = $ARGV[2];
if ($truecrypt_mount eq '') { die "error: no truecrypt mount (put nil if you're not using truecrypt): $!\n"; }
$template = $ARGV[3];
if ($template eq '') { die "error: no template: $!\n"; }
$roqetpad = 'roqetpad.pl';

$templates = XMLin($template);
$page = $templates->{page};
$menu = $templates->{menu};

undef @pod;
@pod = `pod2html $roqetpad`;

open OUT, ">roqetpad.xml" or die "error opening roqetpad.xml: $!\n";
print OUT "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
print OUT "<!-- roqetpad settings -->\n";
print OUT "<parameters>\n";
print OUT "  <!-- user settings -->\n";
print OUT "  <database_instance>" . $instance . "</database_instance>\n";
print OUT "  <truecrypt_volume>" . $truecrypt_volume . "</truecrypt_volume>\n";
print OUT "  <truecrypt_mount>" . $truecrypt_mount . "</truecrypt_mount>\n";
print OUT "  <help><![CDATA[ ";
foreach $i (@pod) {
  chomp($i);
  if ($i =~ /HTML>/) { next; }
  elsif ($i =~ /HEAD>/) { next; }
  elsif ($i =~ /TITLE>/) { next; }
  elsif ($i =~ /LINK REV>/) { next; }
  elsif ($i =~ /BODY>/) { next; }
  elsif ($i =~ /html>/) { next; }
  elsif ($i =~ /head>/) { next; }
  elsif ($i =~ /title>/) { next; }
  elsif ($i =~ /link rev>/) { next; }
  elsif ($i =~ /body style/) { next; }
  elsif ($i =~ /html xmlns/) { next; }
  elsif ($i =~ /link rev/) { next; }
  else {
    if ($i ne '') {
      print OUT "$i\n";
    }
  }
}
print OUT "  ]]></help>\n";
print OUT "  <page><![CDATA[ ";
print OUT "$page\n";
print OUT "  ]]></page>\n";
print OUT "  <menu><![CDATA[ ";
print OUT "$menu\n";
print OUT "  ]]></menu>\n";
print OUT "</parameters>\n";
close OUT;
