#!C:/strawberry/perl/bin/perl.exe
$version = '7.0';
$copyyear = '2011';

=head1 RoqetPad v7.0

  Roqet is proud to present...
  RoqetPad, a personal secure wiki.
  RoqetPad evolved from a contact and note manager to the form
  you see today. The wiki text should be in Roqet Document Format.
  If RoqetPad is used and maintained in accordance within normal 
  operating practices for web-based applications it should 
  provide an eternity of trouble-free operation.
  Please read through this whole document as there are some choices 
  you will need to make before you start the installation process.

=head2 Starting RoqetPad

  Aim your browser at: http://localhost/cgi-bin/roqetpad.cgi
  (change the URL to point to wherever you keep your CGI scripts).

=head1 Using RoqetPad (entering data)

  You can enter any kind of data into RoqetPad, it's not just for
  names and addresses. You could also use it for bookmarks, code-snippets, 
  recipes and many things we haven't thought of yet.

=head2 Roqet Document Format
 
  The RoqetPad uses Roqet Document Format (which is also used by RoqWiki).

  Roqet Document Format v2.1:
  - (comment)
  @ heading (heading) 
  * bullet (depreciated)
  *** bullet (new style)
  *-* horizontal line
  command = description and [examples] (descriptive line)
  [code]
  {{link~~linkname}} 
  {*imagelink*} 
  [[
  preformatted block (puts in <pre></pre> tag block)
  ]]
  - -->import:filename to import an external file

  Example For RoqetPad Use

  Address = 10 Overthere Road, Overthere Place 
  Phone(w) = 444-444-4444 
  Email = {{mailto:name@domain.com~~name}}
  Link = {{http://domain.com~~Fancy Website}}

=head1 Setup

  RoqetPad uses SQLite and TrueCrypt...
  SQLite is very easy to setup and maintain (even for those with
    little or no experience), but it has no security at all. With 
    version 5 of RoqetPad, the option to use TrueCrypt became
    available. Basically, the TrueCrypt volume is mounted prior
    to running a database transaction and dismounted after the 
    transaction is complete. During the transaction, the database
    could be accessed, but as this is only for a brief moment, this
    is quite a secure method of storing your RoqetPad data.
    Please take a look at the TrueCrypt site: http://www.truecrypt.org
    for more details. From RoqetPad 6 the other databases were dropped 
    and SQLite with TrueCrypt became the only option.

=head2 Prerequisites to Installation

  The Perl interpreter must be installed on your system, find it at:
  http://strawberryperl.com
  A webserver needs to be installed or accessible from your system; 
  you can find one at: http://www.apache.org
  The following Perl modules need to be installed, for linux/unix 
  (or Strawberry Perl on Windows):
  perl -MCPAN -e shell
  cpan> install XML::Simple
  cpan> install DBI
  cpan> install DBD::SQLite
  cpan> exit

  may need to...
  perl -MCPAN -e 'force install DBD::SQLite'

=head2 Install

  0. Download RoqetPad: <http://www.roqet.org/software.html>
  1. unzip all the RoqetPad files into a directory.
  2. If you plan on using TrueCrypt to encrypt your data, then you
    will need to create an encrypted volume, and copy the empty
    roqetpad.db file into it, then dismount it and continue here.
    - instructions for creating a TrueCrypt volume can be found
    at: http://www.truecrypt.org. For POSIX installations (Linux,
    Mac OS X etc.) you should download and install TrueCrypt first before
    attempting to install the RoqetPad (a binary hasn't been included
    for non-windows systems due to binary incompatibilities).
  3. Create the roqetpad.xml configuration file as follows:
    perl create_roqetpad_xml.pl "cgi\\" "xml\\" "PATHTOROQETPADDBINSTANCE\roqetpad.db" "nil" 
         "PATHTOTRUECRYPTVOLUME\TRUECRYPTVOLUME" "TRUECRYPTMOUNT" roqetpad_template.xml
    e.g. (windows) perl create_roqetpad_xml.pl "cgi\\" "xml\\" "F:\\roqetpad\roqetpad.db" 
         "nil" "myvolume.tc" "f" roqetpad_template.xml
    e.g. (linux)  perl create_roqetpad_xml.pl "cgi/" "xml/" "/media/truecrypt1/roqetpad.db" 
         "nil" "myvolume.tc" "/media/truecrypt1" roqetpad_template.xml
    NOTE: if you don't want to use TrueCrypt, make the VOLUME and MOUNT parameters "nil", if you
    do want to use TrueCrypt, you will need to create a new volume using TrueCrypt, and
    then copy the roqetpad.db file into that new volume.
  4. Create a copy of roqetpad.pl called roqetpad7.cgi, and edit the top line if the file;
    For linux: #!/usr/bin/perl
    For windows: #!C:/perl/bin/perl.exe
  5. Copy roqetpad7.cgi and roqetpad.xml (and TrueCrypt.exe (or the truecrypt binary)) to your 
    Apache cgi directory.
  6. Copy all the files and directories from the htdocs directory to your Apache 
     htdocs directory.

=head2 Additional Security

  Another recommendation is to use Apache with SSL to encrypt your
  browser sessions: http://httpd.apache.org/docs/2.0/ssl/
  Setting up SSL with Apache is beyond the scope of this document however.

=head2 Scripts + Supporting Files

  roqetpad.pl - the main script that provides user interaction with 
    the database (gets renamed ro roqetpad7.cgi during install process above).
  create_roqetpad_xml.pl - creates the roqetpad.xml XML file (used
    by the roqetpad5.cgi script for database connections, TrueCrypt mounts
    and contains the "help", converted from the RoqetPad POD.
  roqetpad_template.xml - the roqetpad template file. You can change this
    to alter the look'n'feel of the RoqetPad screens (just be careful not
    to change the cgi parameter references (unless you also change these
    within the roqetpad.pl script)).
  roqetpadcmd.pl - a simple script to add, edit, delete and search RoqetPad 
    SQLite data, useful if your web-server isn't currently available.
  htdocs/roqetpad7.css - contains all the formatting settings (cascading style
    sheet).
  htdocs/images/roqetpad71.png - The latest RoqetPad banner.
  sql/CREATE_ROQETPAD_sqlite.sql - a script to create the primary RoqetPad
    tables and triggers.
  sql/create_sqlite_roqetpaddb.sql - a script to run the above script.
  Note: You will need the TrueCrypt binary if you plan to use TrueCrypt;
    TrueCrypt.exe is windows version of the TrueCrypt encryption utility,
    see http://www.truecrypt.org for more details on this encryption
    tool along with licensing information. See Install Notes for using
    TrueCrypt on POSIX installations.

=head1 To Do

  * allow attachments (these would be imported into the database).

=head1 ChangeLog

  2003-09-10: Version 3.0 released. - Initial Perl release. Prior to this
                                      release, the RoqetPad was written in
                                      Delphi and stored its data in an ini
                                      and then xml format. This rewrite 
                                      moved the data into a database and the
                                      application into a browser.
  2004-09-16: Version 3.1 released. - Rebranding.
  2008-01-01: Version 4.0 released. - Initial release for local testing.
  2008-02-15: Version 4.1 released. - Added notes about hyperlinking
                                      between RoqetPad entities.
  2008-12-09: Version 4.2 released. - Added notes about security and
                                      encryption.
  2008-12-10: Version 5.            - Added TrueCrypt optional encryption
                                      for use with a SQLite database;
                                      currently only tested on windows
                                      release will wait until it works
                                      on linux too.
                                      Modified ListAll functionality: now
                                      lists all aliases as a link to the
                                      roqetpad entity detail.
  2009-01-08: Version 5.1           - Parameterized the truecrypt mount
                                      and added mount+dismount commands
                                      for posix-based systems.
  2009-06-30: Version 6.0 released. - The wikification; converted RoqetPad
                                      from the simple contact manager to
                                      a small, secure personal wiki that
                                      can perform all the old RoqetPad
                                      functions and much, much more.
  2011-01-03: Version 7.0 released. - Modified to use a template, so that
                                      the look'n'feel can easily be modified,
				      also did a bit of a code clean-up.

=head1 Author

  roqet <http://www.roqet.org>

=head1 Copyright

  RoqetPad copyright 2011 roqet - (http://www.roqet.org)
  RoqetPad et al can be distributed and modified under the terms of the
  GNU General Public License: http://www.gnu.org/copyleft/gpl.html

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
  GNU General Public License for more details.

  Updates and other scripts and software available at:
  http://www.roqet.org/software.html
   ~~~
   'l'
    -

=cut

use CGI qw/:standard/;
use DBI;
use XML::Simple;
&parseform;

#
# read input parameters and/or environment variables
#
$paramfile = XMLin('./roqetpad.xml');
$database_instance = $paramfile->{database_instance};
$encrypted = 0;
if ($paramfile->{truecrypt_volume} ne 'nil') {
    $truecrypt_volume = $paramfile->{truecrypt_volume};
    $truecrypt_mount = $paramfile->{truecrypt_mount};
    $encrypted = 1;
    $OS =$^O;
    if ($OS eq 'MSWin32') {
        $mount = "TrueCrypt.exe /q /v $truecrypt_volume /l$truecrypt_mount /a /s /p";
        $dismount = "TrueCrypt.exe /q /f /d$truecrypt_mount";
    }
    else {
        $mount = "truecrypt -t --keyfiles= $truecrypt_volume $truecrypt_mount --protect-hidden='no'";
        $dismount = "truecrypt -t -d $truecrypt_mount";
    }
}
$lastword = '';

if (!$key) {
  ( $val1, $val2, $val3 ) = split( /\//, $ENV{'SCRIPT_URL'} );
  $key = $val3;
  #print "Content-type:text/html\n\n";
  #print "$val1, $val2, $val3\n\n";
  #print "</html>";
}

if (!$key) {
  &displaymain;  
}
elsif ($key eq 'add') {
  print "Content-type:text/html\n\n";
  undef (@body);
  addmenu();
  push (@body, '<br />Add - Check Help for Roqet Document Format Notes<hr/>' . "\n");
  push (@body, '<form action="./roqetpad7.cgi" method="post">' . "\n");
  push (@body, '<p>Alias: <input name="alias" value="" type="text" size="45"></p>' . "\n");
  push (@body, '<p>Entry:<br>' . "\n");
  push (@body, '<textarea rows="20" cols="80" name="insert--' . $value . '">' . "\n");
  &getnotes;
  push (@body, "$notes");
  push (@body, '</textarea></p>' . "\n");
  push (@body, '<input type="submit" value="Submit">' . "\n");
  push (@body, '</form>' . "\n");
  readtemplate();
  $titleval = 'Editing ' . $value . ' Page';
  foreach $item (@template) {
    $item =~ s/\(\*title\*\)/$titleval/g;
    if ($item =~ /\(\*body\*\)/) {
      $item =~ s/\(\*body\*\)//g;
      foreach $bit (@body) {
        print "$bit";
      }
    }
    print "$item";
  }
}
elsif ($key eq 'search') {
  # searches for aliases similar to the request
  print "Content-type:text/html\n\n";
  displaydetail(lc($alias),'like');
}
elsif ($key eq 'searchdetail') {
  print "Content-type:text/html\n\n";
  $prepend = '<br />Results <hr/>' . "\n";
  displaydetail($alias,'detail');
}
elsif ($key eq 'admin') {
  # admin page
  print "Content-type:text/html\n\n";
  undef (@body);
  addmenu();
  push (@body, '<br />Roqetpad Administration <hr/>' . "\n");
  push (@body, '<form action="./roqetpad7.cgi" method="post">' . "\n");
  push (@body, '<p><input type="button" value="List All" onClick="window.location=\'./roqetpad7.cgi?listall\'"></p>' . "\n");
  push (@body, '<p><input type="button" value="View History" onClick="window.location=\'./roqetpad7.cgi?listallhistory\'"></p>' . "\n");
  push (@body, '<input type="hidden" name="userLogin" value="0">' . "\n");
  push (@body, '<p>' . "\n");
  push (@body, '<input type="submit" value="Set Password">' . "\n");
  push (@body, '<input name="setpassword" type="password" size="25" value=""> ' . "\n");
  push (@body, '</p>' . "\n");
  push (@body, '</form>' . "\n");
  push (@body, '<form action="./roqetpad7.cgi?searchdetail" method="post">' . "\n");
  push (@body, '<p>' . "\n");
  push (@body, '<input type="submit" value="Search Details">' . "\n");
  push (@body, '<input name="alias" value="" type="text" size="25">' . "\n");
  push (@body, '</p>' . "\n");
  push (@body, '</form>' . "\n");
  readtemplate();
  foreach $item (@template) {
    $item =~ s/\(\*title\*\)/RoqetPad Admin/g;
    $item =~ s/\(\*body\*\)/@body/g;
    print "$item";
  }
}
elsif ($key eq 'look') {
  # looks up and displays detail
  print "Content-type:text/html\n\n";
  displaydetail($value,'equal');
}
elsif (substr($key,0,6) eq 'insert') { 
  # save new record and display page
  print "Content-type:text/html\n\n";
  dbconnect();
  #
  $rc = $dbh->prepare( "INSERT INTO ROQETPAD (ALIAS,DETAIL) VALUES (?, ?)" );
  $rc->bind_param( 1, $alias );
  $rc->bind_param( 2, $value );
  $rc->execute() or print "Error: $DBI::errstr";
  #
  # she flies; sell the bicycle shop, Wilbur!
  if ($rc ne '') { $lastword = "<b>New Entry Added<\/b>"; }
  $rc->finish();
  #
  dbdisconnect();
  #
  displaydetail($alias,'equal');
}
elsif (substr($key,0,6) eq 'update') { 
  # save changes and display page
  print "Content-type:text/html\n\n";
  dbconnect();
  #
  $rc = $dbh->prepare( "UPDATE ROQETPAD SET DETAIL=? WHERE ALIAS=?" );
  $rc->bind_param( 1, $value );
  $rc->bind_param( 2, $alias );
  $rc->execute() or print "Error: $DBI::errstr";
  if ($rc ne '') { $lastword = "<b>Entry Updated<\/b>"; }
  $rc->finish();
  #
  dbdisconnect();
  #
  displaydetail($alias,'equal');
}
elsif ($key eq 'edit') {
  # display source code in an edit box
  print "Content-type:text/html\n\n";
  undef (@body);
  addmenu();
  push (@body, '<br />Edit - Check Help for Roqet Document Format Notes<hr/>' . "\n");
  push (@body, '<form action="./roqetpad7.cgi" method="post">' . "\n");
  push (@body, '<input type="hidden" name="alias" value="' . $value . '">' . "\n");
  push (@body, '<p>Alias: ' . $value .' </p>' . "\n");
  push (@body, '<p>Entry:<br>' . "\n");
  push (@body, '<textarea rows="20" cols="80" name="update--' . $value . '">' . "\n");
  #
  dbconnect();
  #
  $sth = $dbh->prepare("SELECT DETAIL FROM ROQETPAD WHERE ALIAS = ?");
  $sth->bind_param( 1, $value );
  $sth->execute() or output('message', "<b>Error: collecting data!</b> <br /> <i>$DBI::errstr</i>");
  #
  $sth->bind_columns( undef, \$detail );
  while( $sth->fetch() ) {
    push (@body, $detail);
  }
  #
  $sth->finish();
  dbdisconnect();
  #
  push (@body, '</textarea></p>' . "\n");
  push (@body, '<input type="submit" value="Submit">' . "\n");
  push (@body, '</form>' . "\n");
  readtemplate();
  $titleval = 'Editing ' . $value . ' Page';
  foreach $item (@template) {
    $item =~ s/\(\*title\*\)/$titleval/g;
    if ($item =~ /\(\*body\*\)/) {
      $item =~ s/\(\*body\*\)//g;
      foreach $bit (@body) {
        print "$bit";
      }
    }
    print "$item";
  }
}
elsif ($key eq 'delete') { 
  # delete entry
  dbconnect();
  $rc = $dbh->prepare( "DELETE FROM ROQETPAD WHERE ALIAS=?" );
  $rc->bind_param( 1, $value );
  $rc->execute() or print "Error: $DBI::errstr";
  if ($rc ne '') { output('message', "<b>Entry: \"$value\" Deleted.</b>"); }
  $rc->finish();
  dbdisconnect();
}
elsif ($key eq 'deletehistory') { 
  # delete entry
  dbconnect();
  $rc = $dbh->prepare( "DELETE FROM ROQETPAD_HISTORY WHERE ALIAS=?" );
  $rc->bind_param( 1, $value );
  $rc->execute() or print "Error: $DBI::errstr";
  if ($rc ne '') { output('message', "<b>History Entry: \"$value\" Deleted.</b>"); }
  $rc->finish();
  dbdisconnect();
}
elsif ($key eq 'deleteallhistory') { 
  # delete entry
  dbconnect();
  $rc = $dbh->prepare( "DELETE FROM ROQETPAD_HISTORY" );
  $rc->execute() or print "Error: $DBI::errstr";
  if ($rc ne '') { output('message', "<b>All History Deleted.</b>"); }
  $rc->finish();
  dbdisconnect();
}
elsif ($key eq 'setpassword') { 
  # set password cookie and set it to expire in 3 months
  $query = new CGI;
  $rpdcookie = $query->cookie( {-name => 'rpdpwd', -value => $value, -expires =>'+3M'});
  print $query->header( { -cookie => $rpdcookie, -type => "text/html" } );
  output('message', "<b>Password Set</b>");
}
#elsif ($key eq 'testcookie') { 
#  $query = new CGI;
#  $rpdcookie = $query->cookie({-name => 'rpdpwd'});
#  output('message', "<b>Cookie: \"$rpdcookie\"</b>");
#}
elsif ($key eq 'listall') {
  # list all RoqetPad entries
  print "Content-type:text/html\n\n";
  undef (@body);
  addmenu();
  push (@body, '<br />Results <hr/>' . "\n");
  $filecount = 0;
  dbconnect();
  #
  $sth = $dbh->prepare("SELECT ALIAS FROM ROQETPAD");
  $sth->execute() or output('message', "<b>Error: collecting data!</b> <br /> <i>$DBI::errstr</i>");
  #
  $sth->bind_columns( undef, \$alias );
  push(@body,'<div class="dotline"> </div><br />' . "\n");
  while( $sth->fetch() ) {
    push(@body,"<p><a href=\"./roqetpad7.cgi?look=$alias\">$alias</a></p>\n"); 
    $filecount++
  }
  #
  $sth->finish();
  dbdisconnect();
  #
  if (@body[0] eq '') { output('message', "<b>Selection returned No results!</b>"); }
  push (@body, "</ul>\n");
  push (@body, "<p><b>$filecount Entries.<\/b><\/p>\n");
  readtemplate();
  foreach $item (@template) {
    $item =~ s/\(\*title\*\)/RoqetPad List All/g;
    $item =~ s/\(\*body\*\)/@body/g;
    print "$item";
  }
}
elsif ($key eq 'listallhistory') {
  # list all history
  print "Content-type:text/html\n\n";
  undef (@body);
  addmenu();
  push (@body, '<br />Results <hr/>' . "\n");
  $filecount = 0;
  dbconnect();
  #
  $sth = $dbh->prepare("SELECT ALIAS, HIST_TYPE, DATE_MODIFIED FROM ROQETPAD_HISTORY ORDER BY ALIAS");
  $sth->execute() or output('message', "<b>Error: collecting data!</b> <br /> <i>$DBI::errstr</i>");
  #
  $sth->bind_columns( undef, \$alias, \$hist_type, \$date_modified );
  push(@body,'<div class="dotline"> </div><br />' . "\n");
  while( $sth->fetch() ) {
    push(@body,"<p><a href=\"./roqetpad7.cgi?deletehistory=$alias\">delete</a> $date_modified - <b>$alias</b> \"$hist_type\"</p>\n"); 
    $filecount++
  }
  push (@body, '<p><input type="button" value="Delete All History" onClick="window.location=\'./roqetpad7.cgi?deleteallhistory\'"></p>' . "\n");
  #
  $sth->finish();
  dbdisconnect();
  #
  if (@body[0] eq '') { output('message', "<b>Selection returned No results!</b>"); }
  push (@body, "</ul>\n");
  push (@body, "<p><b>$filecount Entries.<\/b><\/p>\n");
  readtemplate();
  foreach $item (@template) {
    $item =~ s/\(\*title\*\)/RoqetPad List All History/g;
    $item =~ s/\(\*body\*\)/@body/g;
    print "$item";
  }
}
elsif ($key eq 'help') {
  # display help page
  print "Content-type:text/html\n\n";
  undef (@body);
  addmenu();
  push (@body, '<br />Help <hr/>' . "\n");
  push (@body, $paramfile->{help} . "\n");
  readtemplate();
  foreach $item (@template) {
    $item =~ s/\(\*title\*\)/RoqetPad Help/g;
    $item =~ s/\(\*body\*\)/@body/g;
    print "$item";
  }
}
else {
  print "Content-type:text/html\n\n";
  undef (@body);
  addmenu();
  push (@body, "\<p\>That entry does not yet exist, \<a href=\"./roqetpad7.cgi\?add\=$key\">Create it?\<\/a\>\<\/p\>");
  readtemplate();
  foreach $item (@template) {
    $item =~ s/\(\*title\*\)/New RoqetPad Entry/g;
    $item =~ s/\(\*body\*\)/@body/g;
    print "$item";
  }
}

###############
#             #
# subroutines #
#             #
###############

sub parseform
#
# parse cgi input
#
{                                    
  if( $ENV{'REQUEST_METHOD'} eq 'GET' ) 
  {	@pairs = split( /&/, $ENV{'QUERY_STRING'} ); }   
  elsif( $ENV{'REQUEST_METHOD'} eq 'POST' ) 
  {                                                   
	read( STDIN, $buffer, $ENV{'CONTENT_LENGTH'} );
	@pairs = split( /&/, $buffer );                          	
	if( $ENV{'QUERY_STRING'} ) 
	{ @getpairs = split( /&/, $ENV{'QUERY_STRING'} );
	  push( @pairs, @getpairs ); }
  }                                                 
  else 
  {                                               
    print "Content-type:text/html\n\n";            
    print "Unrecognized Method - Use GET or POST.";
  }                                                                                                     
  foreach $pair( @pairs ) 
  {                                           
    ( $key, $value ) = split( /=/, $pair );
    $key =~ tr/+/ /;	
    $value =~ tr/+/ /;                                   
    $key =~ s/%(..)/pack("c", hex($1))/eg;                                       
    $value =~ s/%(..)/pack("c", hex($1))/eg;         
    $value =~ s/<!--(.|\n)*-->//g;  		# ignore SSI
    if( $formdata{$key} ){$formdata{$key} .= ", $value";}                                                    
    else{ $formdata{$key} = $value; }                         
    if ($key eq 'alias') { $alias = $value; }
  } 
}

sub displaydetail {
  my $pagename = shift;
  my $type = shift;
  undef @insource;

  dbconnect();

  if ($type eq 'like') { 
    $sth = $dbh->prepare("SELECT ALIAS, DETAIL FROM ROQETPAD WHERE LOWER(ALIAS) LIKE ?"); 
    $sth->bind_param( 1, "%$pagename%" );
  }
  elsif ($type eq 'detail') { 
    $sth = $dbh->prepare("SELECT ALIAS,DETAIL FROM ROQETPAD WHERE LOWER(ALIAS) LIKE ? OR LOWER(DETAIL) LIKE ?");
    $sth->bind_param( 1, "%$pagename%" );
    $sth->bind_param( 2, "%$pagename%" );
  }
  else { 
    $sth = $dbh->prepare("SELECT ALIAS, DETAIL FROM ROQETPAD WHERE ALIAS = ?"); 
    $sth->bind_param( 1, $pagename );
  }
  $sth->execute() or output('message', "<b>Error: collecting data!</b> <br /> <i>$DBI::errstr</i>");

  $sth->bind_columns( undef, \$alias, \$detail );
  while( $sth->fetch() ) {
    push (@insource, '@ ' . "$alias\n");
    push (@insource, '*** {{./roqetpad7.cgi?edit=' . $alias . '~~Edit}} / ' . '{{./roqetpad7.cgi?delete=' . $alias . '~~Delete}}' . "\n");
    #push (@insource, '*** Alias: ' . "$alias" . ' - {{./roqetpad7.cgi?edit=' . $alias . '~~Edit}} / ' . '{{./roqetpad7.cgi?delete=' . $alias . '~~Delete}}' . "\n");
    @details = split("\n",$detail);
    foreach $line( @details ) { push (@insource, $line); }
    if ($type eq 'detail' or $type eq 'like') {   push (@insource, '*-*' . "\n"); }
  }
 
  $sth->finish();
  dbdisconnect();

  if (@insource[0] eq '') { $lastword = "<b>Selection returned No results!<\/b>"; }
  generatehtml($pagename); 
}

sub displaymain {
#
# typically the first page seen
#
  print "Content-type:text/html\n\n";
  undef (@body);
  addmenu();
  readtemplate();
  foreach $item (@template) {
    $item =~ s/\(\*title\*\)/RoqetPad$version Copyright $copyyear/g;
    $item =~ s/\(\*body\*\)/@body/g;
    print "$item";
  }
}

sub addmenu {
#
# the buttons and search at the top of the page
#
  push (@body, $paramfile->{menu} . "\n");
}

sub readtemplate {
#
# create page template
#
  undef @template;
  push (@template, $paramfile->{page} . "\n");
}

sub getnotes {
#
# text to place in the edit box as a guideline
#
  $notes = "- Address = \n" .
  "- Phone(w) = \n" .
  "- Fax = \n" .
  "- Email = {{mailto=name\@domain.com~~name}}\n" .
  "- Link = {{http\:\/\/domain.com~~Fancy Website}}\n\n";
}    

sub generatehtml {
#
# builds html from roqet document format text file
#
  local($source) = @_;
  undef (@body);
  &addmenu;
  push (@body, $prepend . "\n");  
  $pretag = 0;
  foreach $line (@insource) {
    chomp($line);
    if (substr($line,0,3) eq '-->') { 
      ($command,$filename) = split(/\:/,$line,2);
      open IMPORT, $filename or warn "import failure error opening " . $filename . ": $!\n";
      @importfile = <IMPORT>;    
      close IMPORT;
      push (@body, "\n");
      foreach $impline (@importfile) {
        chomp($impline);
        push (@body, $impline . "\n");
      }
      push (@body, "\n\n");
      undef (@importfile);
    }
    elsif (substr($line,0,2) eq '-=') { 
      $line =~ s/\-\=//g;
      $line =~ s/\=\-//g;
      push (@body, "    <h1>$line</h1>\n");
    }
    elsif (substr($line,0,2) eq '* ') {
      # old-style bullets 
      $line =~ s/\* //g;
      push (@body, "    <li />$line\n");
    }
    elsif (substr($line,0,1) eq '-') { next; }
    elsif ($line ne ''){
      if ($line =~ /\[\[/){ 
        $pretag = 1; 
        push (@body, "<pre>\n");
      }
      elsif ($line =~ /\]\]/){
        $pretag = 0; 
        push (@body, "    </pre>\n");
      }
      elsif ( $pretag ){
        push (@body, $line  . "\n");
      }
      else {
        $line =~ s/\</\&lt\;/g;
        $line =~ s/\>/\&gt\;/g;
        $line =~ s/\>/\&gt\;/g;
        $line =~ s/  /\&nbsp\;/g;
        $line =~ s/\[/\<code\>/g;
        $line =~ s/\]/\<\/code\>/g;
        $line =~ s/\{\*/\<img src\=\"/g;
        $line =~ s/\*\}/\" border \=\"0\"\>/g;
        $line =~ s/\{\{/\<a href\=\"/g;
        $line =~ s/\~\~/\"\>/g;
        $line =~ s/\}\}/\<\/a\>/g;
        if (substr($line,0,2) eq '@ ') { 
          $line =~ s/\@ //g;
          $line = "    <h2>$line</h2>";
        }
        # new-style bullet
        $line =~ s/\*\*\* /    \<li \/\>/g;
        $line =~ s/\*\-\*/\<hr \/\>/g;
        if ($line =~ /\= /){ 
          ($comm,$desc) = split(/\=/,$line,2);
          push (@body, "    <p><b>$comm</b>: $desc</p>\n");
        }
        else {
          $comm = $line;
          $desc = '';
          push (@body, "    <p>\n    " . $comm . $desc . "\n    </p>\n");
        }
      }
    }	  
  }
  if ($lastword ne '') {
    push (@body, '<br />Message <hr/>' . "\n"); 
    push (@body, "<p>$lastword</p>\n"); 
    $lastword = '';
  }
  readtemplate();
  foreach $item (@template) {
    $item =~ s/\(\*title\*\)/$source/g;
    if ($item =~ /\(\*body\*\)/) {
      $item =~ s/\(\*body\*\)//g;
      foreach $bit (@body) { print "$bit"; }
    }
    print "$item";
  }
}

sub dbconnect {
#
# connect to database
#
  if ($encrypted) {
    $query = new CGI;
    $password = $query->cookie({-name => 'rpdpwd'});
    `$mount $password`;
  }
  $dbh = DBI->connect( "dbi:SQLite:$database_instance" )
    or output('message', "<b>Error: Can't connect to SQLite database:</b> <br /> <i>$DBI::errstr!</i> <br />Check your connection details.\n");
}

sub dbdisconnect {
#
# disconnect from database
#
  $dbh->disconnect or output('message', "<b>Error: Database disconnect failed:</b>  <br /> <i>$DBI::errstr!</i>");
  if ($encrypted) {
    $query = new CGI;
    $password = $query->cookie({-name => 'rpdpwd'});
    `$dismount`;
  }
}

sub output {
#
# output messages
#
  local($type,$message) = @_;
  print "Content-type:text/html\n\n";
  undef (@body);
  if ($type eq 'feedback') { push (@body, '<br />Message <hr/>' . "\n"); }
  if ($type eq 'message') { 
    &addmenu;
    push (@body, '<br />Message <hr/>' . "\n"); 
  }
  push (@body, "$message\n");
  readtemplate();
  foreach $item (@template) {
    $item =~ s/\(\*title\*\)/RoqetPad Message/g;
    $item =~ s/\(\*body\*\)/@body/g;
    print "$item";
  }
}

__END__

