-- -------------------------------------------------------
-- RoqetPad
-- Script to create:
--   roqetpad table
--   roqetpad history table
--   roqetpad triggers
-- -------------------------------------------------------

CREATE TABLE ROQETPAD
(
  ALIAS          VARCHAR2(100) primary key,
  DETAIL         BLOB,
  DATE_MODIFIED  DATE
);

CREATE TABLE ROQETPAD_HISTORY
(
  ALIAS          VARCHAR2(100),
  HIST_TYPE      VARCHAR2(100),
  DATE_MODIFIED  DATE
);

DROP TRIGGER RPD_T_INS_ROQETPAD;

CREATE TRIGGER RPD_T_INS_ROQETPAD AFTER INSERT ON ROQETPAD
BEGIN
  UPDATE ROQETPAD SET DATE_MODIFIED = CURRENT_TIMESTAMP
  WHERE rowid = new.rowid;
  INSERT INTO ROQETPAD_HISTORY (ALIAS, HIST_TYPE, DATE_MODIFIED)
  VALUES( new.ALIAS, 'INSERT', CURRENT_TIMESTAMP);
END;

DROP TRIGGER RPD_T_UPD_ROQETPAD;

CREATE TRIGGER RPD_T_UPD_ROQETPAD UPDATE ON ROQETPAD
BEGIN
  UPDATE ROQETPAD SET DATE_MODIFIED = CURRENT_TIMESTAMP
  WHERE ALIAS = old.ALIAS;
  INSERT INTO ROQETPAD_HISTORY (ALIAS, HIST_TYPE, DATE_MODIFIED)
  VALUES( old.ALIAS, 'UPDATE', CURRENT_TIMESTAMP);
END;

DROP TRIGGER RPD_T_DEL_ROQETPAD;

CREATE TRIGGER RPD_T_DEL_ROQETPAD DELETE ON ROQETPAD
BEGIN
  INSERT INTO ROQETPAD_HISTORY (ALIAS, HIST_TYPE, DATE_MODIFIED)
  VALUES( old.ALIAS, 'DELETE', CURRENT_TIMESTAMP);
END;

